import NextAuth from 'next-auth'
import KeycloakProvider from 'next-auth/providers/keycloak'
// import { UnstorageAdapter } from '@auth/unstorage-adapter'
// import { createStorage } from 'unstorage'

// const storage = createStorage()

export const authOptions = {
  // adapter: UnstorageAdapter(storage),
  session: {
    maxAge: 172800 // 48h
  },
  debug: true,
  // Configure one or more authentication providers
  providers: [
    // !!! Should be stored in .env file.
    KeycloakProvider({
      // clientId: 'fdo-manager-webui',
      clientId: 'gwdg-fdoman-test',
      // clientSecret: 'ay7l6jhECSohAZsEp6HYOaoXdARMQCei',
      clientSecret: process.env.KEY_CLOAK_CLIENT_SECRET || '',
      // issuer: 'http://localhost:8000/auth/realms/fdo-manager',
      issuer: 'https://keycloak.sso.gwdg.de/auth/realms/academiccloud',
      // authorization: { params: { scope: 'openid profile email' } },
      profile (profile) {
        console.log('### profile', profile, '### ### ###')
        return {
          id: profile.sub,
          name: profile.name ?? profile.preferred_username
        }
      }
    })
  ],
  callbacks: {
    async signIn ({ user, account, profile, email, credentials }: any) {
      console.log('### signIn', user, account, profile, email, credentials, '### ### ###')
      return true
    },
    async session ({ session, user, token }: any) {
      console.log('### session', session, user, token, '### ### ###')
      return {
        ...session,
        account: token.account
      }
    },
    async redirect ({ url, baseUrl }: any) {
      console.log('### redirect', url, baseUrl, '### ### ###')
      return Promise.resolve(url)
    },
    async jwt ({ token, user, account, profile, isNewUser }: any) {
      console.log('### jwt', token, user, account, profile, isNewUser, '### ### ###')
      if (account) {
        return {
          ...token,
          account
        }
      }
      return token
    }
  },
  secret: 'UItTuD1HcGXIj8ZfHUswhYdNd40Lc325R8VlxQPUoR0='
}
export default NextAuth(authOptions)
